(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(declare-sort Prog2 0)
(declare-fun ZERO () Prog2)
(declare-fun ONE () Prog2)
(declare-fun TWO () Prog2)
(declare-fun ADDI (Prog2 Prog2) Prog2)
(declare-fun DIFF (Prog2 Prog2) Prog2)
(declare-fun MULT (Prog2 Prog2) Prog2)
(declare-fun DIVI (Prog2 Prog2) Prog2)
(declare-fun MODU (Prog2 Prog2) Prog2)
(declare-fun COND (Prog2 Prog2 Prog2) Prog2)
(declare-fun LOOP (Prog2 Prog2 Prog2) Prog2)
(declare-fun LOOP2 (Prog2 Prog2 Prog2 Prog2 Prog2) Prog2)
(declare-fun X () Prog2)
(declare-fun Y () Prog2)
(declare-fun ev2 (Prog2 Int Int) Int)
(declare-fun ev2loop2 (Prog2 Prog2 Int Int Int) Int)
(assert (forall ((m Int) (n Int)) (= (ev2 ZERO m n) 0)))
(assert (forall ((m Int) (n Int)) (= (ev2 ONE m n) 1)))
(assert (forall ((m Int) (n Int)) (= (ev2 TWO m n) 2)))
(assert (forall ((m Int) (n Int)) (= (ev2 X m n) m)))
(assert (forall ((m Int) (n Int)) (= (ev2 Y m n) n)))
(assert (forall ((p Prog2) (q Prog2) (m Int) (n Int)) (= (ev2 (ADDI p q) m n) (+ (ev2 p m n) (ev2 q m n)))))
(assert (forall ((p Prog2) (q Prog2) (m Int) (n Int)) (= (ev2 (DIFF p q) m n) (- (ev2 p m n) (ev2 q m n)))))
(assert (forall ((p Prog2) (q Prog2) (m Int) (n Int)) (= (ev2 (MULT p q) m n) (* (ev2 p m n) (ev2 q m n)))))
(assert (forall ((p Prog2) (q Prog2) (m Int) (n Int)) (= (ev2 (DIVI p q) m n) (div (ev2 p m n) (ev2 q m n)))))
(assert (forall ((p Prog2) (q Prog2) (m Int) (n Int)) (= (ev2 (MODU p q) m n) (mod (ev2 p m n) (ev2 q m n)))))
(assert (forall ((p Prog2) (q Prog2) (r Prog2) (m Int) (n Int)) (=> (<= (ev2 p m n) 0) (= (ev2 (COND p q r) m n) (ev2 q m n)))))
(assert (forall ((p Prog2) (q Prog2) (r Prog2) (m Int) (n Int)) (=> (> (ev2 p m n) 0) (= (ev2 (COND p q r) m n) (ev2 r m n)))))
(assert (forall ((p Prog2) (q Prog2) (r Prog2) (m Int) (n Int)) (=> (<= (ev2 q m n) 0) (= (ev2 (LOOP p q r) m n) (ev2 r m n)))))
(assert (forall ((p Prog2) (q Prog2) (r Prog2) (m Int) (n Int)) (=> (> (ev2 q m n) 0) (= (ev2 (LOOP p q r) m n) (ev2 p (ev2 (LOOP p (DIFF q ONE) r) m n) m)))))
(assert (forall ((f Prog2) (g Prog2) (a Prog2) (b Prog2) (c Prog2) (m Int) (n Int)) (= (ev2 (LOOP2 f g a b c) m n) (ev2loop2 f g (ev2 a m n) (ev2 b m n) (ev2 c m n)))))
(assert (forall ((f Prog2) (g Prog2) (va Int) (vb Int) (vc Int)) (=> (<= va 0) (= (ev2loop2 f g va vb vc) vb))))
(assert (forall ((f Prog2) (g Prog2) (va Int) (vb Int) (vc Int)) (=> (> va 0) (= (ev2loop2 f g va vb vc) (ev2loop2 f g (- va 1) (ev2 f vb vc) (ev2 g vb vc))))))
(assert (not (forall ((n Int)) (=> (<= 0 n)
 (= (ev2 (MULT TWO (LOOP2 (DIFF Y X) (ADDI (ADDI Y Y) Y) X ZERO TWO)) n 0)
     (ev2 (DIFF (LOOP (ADDI (ADDI X X) X) X ONE) (LOOP (DIFF ZERO X) X ONE)) n 0))))))

(check-sat)
